/*--------------------------
	include
--------------------------*/
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <commctrl.h>
#include <DDEML.H>

#include "resource.h"

/*--------------------------
	define
--------------------------*/
#define BUFSIZE				256
#define MAXSIZE				32768

#define BROWSE_CNT			500

#define WM_GETBROUSERINFO	(WM_USER + 1)

/*--------------------------
	Global
--------------------------*/

/*--------------------------
	function
--------------------------*/

//DDE Callback
HDDEDATA CALLBACK DDECallback(WORD wType, WORD wFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD lData1, DWORD lData2)
{
	return (HDDEDATA)0;
}

//ŌɃANeBuuEUANeBuɂ
DWORD DDE_SetActiveBrowser(char *browser)
{
	HSZ hszService;
	HSZ hszTopic;
	HSZ hszParam;
	HCONV hConv;
	HDDEDATA hDDEData;
	DWORD dwActivateID = 0;
	DWORD m_dwDDEID = 0;

	//DDȄ
	if(DdeInitialize(&m_dwDDEID, (PFNCALLBACK)MakeProcInstance((FARPROC)DDECallback, AfxGetInstanceHandle()),
		CBF_SKIP_ALLNOTIFICATIONS | APPCMD_CLIENTONLY, 0L) != DMLERR_NO_ERROR){
		MessageBox(NULL, "DDȄɎs܂B","uEU̎擾", MB_ICONWARNING | MB_OK);
		return 0;
	}

	hszService = DdeCreateStringHandle(m_dwDDEID, browser, 0);
	hszTopic = DdeCreateStringHandle(m_dwDDEID, "WWW_Activate", 0);
	//DDE Connect
	hConv = DdeConnect(m_dwDDEID, hszService, hszTopic, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszTopic);
	DdeFreeStringHandle(m_dwDDEID, hszService);
	if(hConv == 0){
		DdeUninitialize(m_dwDDEID);
		return 0;
	}

	// 0xFFFFFFFF ͍ŌɃANeBuuEUwB
	// uEUIDw肷Ƃ̃uEUANeBuɂB
	hszParam = DdeCreateStringHandle(m_dwDDEID, "0xFFFFFFFF,0x0", 0);
	//Client Transaction
	hDDEData = DdeClientTransaction(NULL, 0, hConv, hszParam, CF_TEXT, XTYP_REQUEST, 10000L, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszParam);
	if(hDDEData == 0){
		DdeDisconnect(hConv);
		DdeUninitialize(m_dwDDEID);
		return 0;
	}

	//Get Data
	//ANeBuɂuEUID擾
	DdeGetData(hDDEData, (LPBYTE)&dwActivateID, sizeof(DWORD), 0);

    DdeFreeDataHandle(hDDEData);
	DdeDisconnect(hConv);
	DdeUninitialize(m_dwDDEID);
	return dwActivateID;
}

//ŌɃANeBuuEUURL𑗂
BOOL DDE_SetBrowseURL(char *browser, char *URL)
{
	HSZ hszService;
	HSZ hszTopic;
	HSZ hszParam;
	HCONV hConv;
	HDDEDATA hDDEData;
	DWORD m_dwDDEID = 0;
	char sParam[BUFSIZE];

	//DDȄ
	if(DdeInitialize(&m_dwDDEID, (PFNCALLBACK)MakeProcInstance((FARPROC)DDECallback, AfxGetInstanceHandle()),
		CBF_SKIP_ALLNOTIFICATIONS | APPCMD_CLIENTONLY, 0L) != DMLERR_NO_ERROR){
		MessageBox(NULL, "DDȄɎs܂B","uEU̎擾", MB_ICONWARNING | MB_OK);
		return FALSE;
	}

	hszService = DdeCreateStringHandle(m_dwDDEID, browser, 0);
	hszTopic = DdeCreateStringHandle(m_dwDDEID, "WWW_OpenURL", 0);
	//DDE Connect
	hConv = DdeConnect(m_dwDDEID, hszService, hszTopic, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszService);
	DdeFreeStringHandle(m_dwDDEID, hszTopic);
	if(hConv == 0){
		DdeUninitialize(m_dwDDEID);
		return FALSE;
	}

	// 0xFFFFFFFF ͍ŌɃANeBuuEUwB
	//uEUIDw肷Ƃ̃uEUURL𑗂B
	wsprintf(sParam, "\"%s\",,0xFFFFFFFF,0x0,,,", URL);
	hszParam = DdeCreateStringHandle(m_dwDDEID, (LPCSTR)sParam, 0);
	//Client Transaction
	hDDEData = DdeClientTransaction(NULL, 0, hConv, hszParam, CF_TEXT, XTYP_REQUEST, 10000L, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszParam);

    DdeFreeDataHandle(hDDEData);
	DdeDisconnect(hConv);
	DdeUninitialize(m_dwDDEID);

	//uEUANeBuɂ
	DDE_SetActiveBrowser(browser);
	return TRUE;
}


//ŌɃANeBuuEȔ̎擾
BOOL DDE_GetActiveBrowseInfo(char *browser, char *RetInfo, int RetInfoLen)
{
	HSZ hszService;
	HSZ hszTopic;
	HSZ hszParam;
	HCONV hConv;
	HDDEDATA hDDEData;
	DWORD m_dwDDEID = 0;

	//DDȄ
	if(DdeInitialize(&m_dwDDEID, (PFNCALLBACK)MakeProcInstance((FARPROC)DDECallback, AfxGetInstanceHandle()),
		CBF_SKIP_ALLNOTIFICATIONS | APPCMD_CLIENTONLY, 0L) != DMLERR_NO_ERROR){
		MessageBox(NULL, "DDȄɎs܂B","uEU̎擾", MB_ICONWARNING | MB_OK);
		return FALSE;
	}

	hszService = DdeCreateStringHandle(m_dwDDEID, browser, 0);
	hszTopic = DdeCreateStringHandle(m_dwDDEID, "WWW_GetWindowInfo", 0);
	//DDE Connect
	hConv = DdeConnect(m_dwDDEID, hszService, hszTopic, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszTopic);
	DdeFreeStringHandle(m_dwDDEID, hszService);
	if(hConv == 0){
		DdeUninitialize(m_dwDDEID);
		return FALSE;
	}
	
	// 0xFFFFFFFF ͍ŌɃANeBuuEUwB
	// uEUIDw肷Ƃ̃uEȔĂB
	hszParam = DdeCreateStringHandle(m_dwDDEID, "0xFFFFFFFF", 0);
	//Client Transaction
	hDDEData = DdeClientTransaction(NULL, 0, hConv, hszParam, CF_TEXT, XTYP_REQUEST, 10000L, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszParam);
	if(hDDEData == 0){
		DdeDisconnect(hConv);
		DdeUninitialize(m_dwDDEID);
		return FALSE;
	}
	
	//Get Data
	DdeGetData(hDDEData, (LPBYTE)RetInfo, RetInfoLen, 0);

	DdeFreeDataHandle(hDDEData);
	DdeDisconnect(hConv);
	DdeUninitialize(m_dwDDEID);
	return TRUE;
}

//uEŨXguEU擾Ďw̃EBhEbZ[WŃEBhEɓnB
int DDE_GetBrowseInfoList(HWND hWnd, UINT sMsg, char *browser)
{
	HSZ hszService;
	HSZ hszTopic;
	HSZ hszParam;
	HCONV hConv;
	HDDEDATA hDDEData;
	DWORD dwIDList[BROWSE_CNT];
	DWORD m_dwDDEID = 0;
	char *gbuf;
	char tmp[BUFSIZE];
	int i;

	//DDȄ
	if(DdeInitialize(&m_dwDDEID, (PFNCALLBACK)MakeProcInstance((FARPROC)DDECallback, AfxGetInstanceHandle()),
		CBF_SKIP_ALLNOTIFICATIONS | APPCMD_CLIENTONLY, 0L) != DMLERR_NO_ERROR){
		MessageBox(NULL, "DDȄɎs܂B","uEU̎擾", MB_ICONWARNING | MB_OK);
		return 0;
	}

	//uEUIDXg擾
	hszService = DdeCreateStringHandle(m_dwDDEID, browser, 0);
	hszTopic = DdeCreateStringHandle(m_dwDDEID, "WWW_ListWindows", 0);
	//DDE Connect
	hConv = DdeConnect(m_dwDDEID, hszService, hszTopic, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszService);
 	DdeFreeStringHandle(m_dwDDEID, hszTopic);
	if(hConv == 0){
		DdeUninitialize(m_dwDDEID);
		return 0;
	}
	hszParam = DdeCreateStringHandle(m_dwDDEID, "0xFFFFFFFF", 0);
	//Client Transaction
	hDDEData = DdeClientTransaction(NULL, 0, hConv, hszParam, CF_TEXT, XTYP_REQUEST, 10000L, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszParam);
	if(hDDEData == 0){
		DdeDisconnect(hConv);
		DdeUninitialize(m_dwDDEID);
		return 0;
	}

	memset(dwIDList, 0, sizeof(dwIDList));
	//Get Data
	DdeGetData(hDDEData, (LPBYTE)dwIDList, sizeof(dwIDList), 0);

	DdeFreeDataHandle(hDDEData);
	DdeDisconnect(hConv);

	//uEUIDuEȔ擾
	hszService = DdeCreateStringHandle(m_dwDDEID, browser, 0);
	hszTopic = DdeCreateStringHandle(m_dwDDEID, "WWW_GetWindowInfo", 0);
	//DDE Connect
	hConv = DdeConnect(m_dwDDEID, hszService, hszTopic, NULL);
	DdeFreeStringHandle(m_dwDDEID, hszService);
	DdeFreeStringHandle(m_dwDDEID, hszTopic);
	if(hConv == 0){
		DdeUninitialize(m_dwDDEID);
		return 0;
	}

	i = 0;
	gbuf = (char *)GlobalAlloc(GPTR, MAXSIZE);

	while(i < BROWSE_CNT && dwIDList[i] != 0){
		wsprintf(tmp, "%d", dwIDList[i]);		//uEUID
		hszParam = DdeCreateStringHandle(m_dwDDEID, tmp, 0);
		//Client Transaction
		hDDEData = DdeClientTransaction(NULL, 0, hConv, hszParam, CF_TEXT, XTYP_REQUEST, 10000L, NULL);
		DdeFreeStringHandle(m_dwDDEID, hszParam);
		if(hDDEData == 0){
			i++;
			continue;
		}

		//Get Data
		DdeGetData(hDDEData, (LPBYTE)gbuf, MAXSIZE - 1, 0);

		DdeFreeDataHandle(hDDEData);

		//wEBhEɎw胁bZ[WŎ擾n
		SendMessage(hWnd, sMsg, 0, (LPARAM)gbuf);
		i++;
	}
	GlobalFree(gbuf);

	DdeDisconnect(hConv);
	DdeUninitialize(m_dwDDEID);
	return 1;
}



//DDEŃuEU擾 URL , Title , Frame ɓWJ
//	"http://hoge.com/","hoge","Frame"
void GetDDEStr(char *buf, char *URL, char *Title, char *Frame)
{
	char *p, *r;
	
	p = (char *)buf;

	if(*p == '\"'){
		p++;
	}
	for(r = URL;*p != '\"' && *p != '\0';p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
		}else if(*p == '\\'){
			p++;
		}
		*(r++) = *p;
	}
	*r = '\0';

	for(;(*p == '\"' || *p == ',') && *p != '\0';p++);

	for(r = Title;*p != '\"' && *p != '\0';p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
		}else if(*p == '\\'){
			p++;
		}
		*(r++) = *p;
	}
	*r = '\0';

	for(;(*p == '\"' || *p == ',') && *p != '\0';p++);

	for(r = Frame;*p != '\"' && *p != '\0';p++){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
		}else if(*p == '\\'){
			p++;
		}
		*(r++) = *p;
	}
	*r = '\0';
}

//Xgr[̍ŌɃACeǉB
int SetListItem(HWND hListView, char *buf, int buflen)
{
	LV_ITEM lvi;

	lvi.mask = LVIF_TEXT | LVIF_PARAM;

	lvi.iItem = ListView_GetItemCount(hListView);
	lvi.iSubItem = 0;
	lvi.pszText = buf;
	lvi.cchTextMax = buflen;
	lvi.iImage = 0;
	lvi.lParam = 0;

	// Xgr[ɃACeǉ
	return ListView_InsertItem(hListView, &lvi);
}

BOOL CALLBACK MainProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LV_COLUMN lvc;
	char Title[BUFSIZE], URL[BUFSIZE], Frame[BUFSIZE];
	char InfoStr[MAXSIZE];
	int i;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		i = 0;
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

		lvc.fmt = LVCFMT_LEFT;

		lvc.cx = 200;
		lvc.pszText = "^Cg";
		lvc.iSubItem = i;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST), i, &lvc);

		i++;
		lvc.cx = 100;
		lvc.pszText = "t[";
		lvc.iSubItem = i;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST), i, &lvc);

		i++;
		lvc.cx = 500;
		lvc.pszText = "URL";
		lvc.iSubItem = i;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST), i, &lvc);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		//uEUURL𑗂B
		case IDC_BUTTON_SETURL:
			URL[0] = '\0';
			SendMessage(GetDlgItem(hDlg, IDC_EDIT_URL), WM_GETTEXT, BUFSIZE - 1, (LPARAM)URL);
			if(URL[0] == '\0'){
				break;
			}
			
			//IENĂȂꍇ́ANetscapeB
			if(DDE_SetBrowseURL("IEXPLORE", URL) == FALSE){
				if(DDE_SetBrowseURL("NETSCAPE", URL) == FALSE){
					//uEUNĂȂꍇ̓VXeftHg̃uEUNB
					ShellExecute((HWND)NULL, (LPCTSTR)"open", (LPCTSTR)URL, NULL, NULL, SW_SHOWNORMAL);
				}
			}
			break;

		//uEU擾B
		case IDC_BUTTON_GETURL:
			//IENĂȂꍇ́ANetscapeB
			if(DDE_GetActiveBrowseInfo("IEXPLORE", InfoStr, MAXSIZE - 1) == FALSE){
				if(DDE_GetActiveBrowseInfo("NETSCAPE", InfoStr, MAXSIZE - 1) == FALSE){
					MessageBox(hDlg, "uEUNĂȂAuEU̎擾Ɏs܂B",
						"uEU̎擾", MB_ICONWARNING | MB_OK);
					break;
				}
			}
			//擾WJB
			GetDDEStr(InfoStr, URL, Title, Frame);

			SendMessage(GetDlgItem(hDlg, IDC_EDIT_URL), WM_SETTEXT, 0, (LPARAM)URL);
			break;

		//̃uEU擾B
		case IDC_BUTTON_GETLIST:
			ListView_DeleteAllItems(GetDlgItem(hDlg, IDC_LIST));

			//IENĂȂꍇ́ANetscapeB
			i = 0;
			i |= DDE_GetBrowseInfoList(hDlg, WM_GETBROUSERINFO, "IEXPLORE");
			i |= DDE_GetBrowseInfoList(hDlg, WM_GETBROUSERINFO, "NETSCAPE");
			
			if(i == 0 || ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST)) == 0){
				MessageBox(hDlg, "uEUNĂȂAuEU̎擾Ɏs܂B",
					"uEU̎擾", MB_ICONWARNING | MB_OK);
			}
			break;
		}
		break;

	case WM_GETBROUSERINFO:
		//DDEŎ擾WJB
		GetDDEStr((char *)lParam, URL, Title, Frame);
		
		if(Title[0] == '\0' && URL[0] == '\0'){
			break;
		}
		
		//Xgr[̍ŌɒǉsB
		i = SetListItem(GetDlgItem(hDlg, IDC_LIST), Title, BUFSIZE);
		ListView_SetItemText(GetDlgItem(hDlg, IDC_LIST), i, 1, Frame);
		ListView_SetItemText(GetDlgItem(hDlg, IDC_LIST), i, 2, URL);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	InitCommonControls();

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, MainProc);
	return 0;
}
